]> jfr.im git - yt-dlp.git/blame - devscripts/release.sh
release 2016.05.21.1
[yt-dlp.git] / devscripts / release.sh
CommitLineData
55e286ba 1#!/bin/bash
225dceb0 2
b962b76f 3# IMPORTANT: the following assumptions are made
6e3dba16 4# * the GH repo is on the origin remote
b962b76f
FV
5# * the gh-pages branch is named so locally
6# * the git config user.signingkey is properly set
7
8# You will need
9# pip install coverage nose rsa
10
6e3dba16
FV
11# TODO
12# release notes
13# make hash on local files
14
b962b76f
FV
15set -e
16
0f8f0971
PH
17skip_tests=true
18if [ "$1" = '--run-tests' ]; then
19 skip_tests=false
d3a8613b 20 shift
d71cae62 21fi
964ac8b5 22
225dceb0
FV
23if [ -z "$1" ]; then echo "ERROR: specify version number like this: $0 1994.09.06"; exit 1; fi
24version="$1"
4c094185
PH
25major_version=$(echo "$version" | sed -n 's#^\([0-9]*\.[0-9]*\.[0-9]*\).*#\1#p')
26if test "$major_version" '!=' "$(date '+%Y.%m.%d')"; then
27 echo "$version does not start with today's date!"
28 exit 1
29fi
30
225dceb0 31if [ ! -z "`git tag | grep "$version"`" ]; then echo 'ERROR: version already present'; exit 1; fi
b962b76f 32if [ ! -z "`git status --porcelain | grep -v CHANGELOG`" ]; then echo 'ERROR: the working directory is not clean; commit or stash changes'; exit 1; fi
50144133
PH
33useless_files=$(find youtube_dl -type f -not -name '*.py')
34if [ ! -z "$useless_files" ]; then echo "ERROR: Non-.py files in youtube_dl: $useless_files"; exit 1; fi
b962b76f 35if [ ! -f "updates_key.pem" ]; then echo 'ERROR: updates_key.pem missing'; exit 1; fi
7e642e4f 36if ! type pandoc 2>/dev/null; then echo 'ERROR: pandoc is missing'; exit 1; fi
b962b76f 37
a72b0f2b 38/bin/echo -e "\n### First of all, testing..."
d200b11c 39make clean
964ac8b5 40if $skip_tests ; then
d71cae62
PH
41 echo 'SKIPPING TESTS'
42else
43 nosetests --verbose --with-coverage --cover-package=youtube_dl --cover-html test --stop || exit 1
44fi
b962b76f 45
a72b0f2b 46/bin/echo -e "\n### Changing version in version.py..."
4da769cc 47sed -i "s/__version__ = '.*'/__version__ = '$version'/" youtube_dl/version.py
b962b76f 48
4a5a67ca 49/bin/echo -e "\n### Committing documentation, templates and youtube_dl/version.py..."
be0c7009 50make README.md CONTRIBUTING.md .github/ISSUE_TEMPLATE.md supportedsites
4a5a67ca 51git add README.md CONTRIBUTING.md .github/ISSUE_TEMPLATE.md docs/supportedsites.md youtube_dl/version.py
225dceb0 52git commit -m "release $version"
b962b76f 53
a72b0f2b 54/bin/echo -e "\n### Now tagging, signing and pushing..."
b962b76f
FV
55git tag -s -m "Release $version" "$version"
56git show "$version"
57read -p "Is it good, can I push? (y/n) " -n 1
58if [[ ! $REPLY =~ ^[Yy]$ ]]; then exit 1; fi
59echo
6e3dba16
FV
60MASTER=$(git rev-parse --abbrev-ref HEAD)
61git push origin $MASTER:master
62git push origin "$version"
b962b76f 63
a72b0f2b 64/bin/echo -e "\n### OK, now it is time to build the binaries..."
b962b76f
FV
65REV=$(git rev-parse HEAD)
66make youtube-dl youtube-dl.tar.gz
6c603ccc
PH
67read -p "VM running? (y/n) " -n 1
68wget "http://localhost:8142/build/rg3/youtube-dl/youtube-dl.exe?rev=$REV" -O youtube-dl.exe
09f9552b
PH
69mkdir -p "build/$version"
70mv youtube-dl youtube-dl.exe "build/$version"
71mv youtube-dl.tar.gz "build/$version/youtube-dl-$version.tar.gz"
db2d6124 72RELEASE_FILES="youtube-dl youtube-dl.exe youtube-dl-$version.tar.gz"
09f9552b
PH
73(cd build/$version/ && md5sum $RELEASE_FILES > MD5SUMS)
74(cd build/$version/ && sha1sum $RELEASE_FILES > SHA1SUMS)
75(cd build/$version/ && sha256sum $RELEASE_FILES > SHA2-256SUMS)
76(cd build/$version/ && sha512sum $RELEASE_FILES > SHA2-512SUMS)
b962b76f 77
d2d1eb5b 78/bin/echo -e "\n### Signing and uploading the new binaries to yt-dl.org ..."
cc88b90e 79for f in $RELEASE_FILES; do gpg --passphrase-repeat 5 --detach-sig "build/$version/$f"; done
ead28ff3
PH
80scp -r "build/$version" ytdl@yt-dl.org:html/tmp/
81ssh ytdl@yt-dl.org "mv html/tmp/$version html/downloads/"
ea93cce4 82ssh ytdl@yt-dl.org "sh html/update_latest.sh $version"
b962b76f 83
a72b0f2b 84/bin/echo -e "\n### Now switching to gh-pages..."
09f9552b
PH
85git clone --branch gh-pages --single-branch . build/gh-pages
86ROOT=$(pwd)
87(
88 set -e
09f9552b 89 ORIGIN_URL=$(git config --get remote.origin.url)
3b83bf8f 90 cd build/gh-pages
09f9552b 91 "$ROOT/devscripts/gh-pages/add-version.py" $version
60607880 92 "$ROOT/devscripts/gh-pages/update-feed.py"
bb289989 93 "$ROOT/devscripts/gh-pages/sign-versions.py" < "$ROOT/updates_key.pem"
09f9552b
PH
94 "$ROOT/devscripts/gh-pages/generate-download.py"
95 "$ROOT/devscripts/gh-pages/update-copyright.py"
69100808 96 "$ROOT/devscripts/gh-pages/update-sites.py"
09f9552b
PH
97 git add *.html *.html.in update
98 git commit -m "release $version"
3b83bf8f 99 git push "$ROOT" gh-pages
bb289989 100 git push "$ORIGIN_URL" gh-pages
09f9552b 101)
253d96f2 102rm -rf build
b962b76f 103
434eb6f2 104make pypi-files
450a30ca 105echo "Uploading to PyPi ..."
4056ad8f 106python setup.py sdist bdist_wheel upload
434eb6f2 107make clean
450a30ca 108
a72b0f2b 109/bin/echo -e "\n### DONE!"